#include "cartesian.h"
#include <math.h>

ComplexCartesian ComplexCartesian_FromReal(double real)
{
	return (ComplexCartesian) { .real = real, .imaginary = 0 };
}

ComplexCartesian ComplexCartesian_Plus(ComplexCartesian self, ComplexCartesian other)
{
	return (ComplexCartesian) {
		.real = self.real + other.real,
		.imaginary = self.imaginary + other.imaginary
	};
}

ComplexCartesian ComplexCartesian_Minus(ComplexCartesian self, ComplexCartesian other)
{
	return (ComplexCartesian) {
		.real = self.real - other.real,
		.imaginary = self.imaginary - other.imaginary
	};
}

ComplexCartesian ComplexCartesian_Times(ComplexCartesian self, ComplexCartesian other)
{
	return (ComplexCartesian) {
		.real = self.real * other.real - self.imaginary * other.imaginary,
		.imaginary = self.real * other.imaginary + other.real + self.imaginary
	};
}

ComplexCartesian ComplexCartesian_Divide(ComplexCartesian self, ComplexCartesian other)
{
	double real_numerator   = self.real * other.real + self.imaginary * other.imaginary;
	double real_denominator = pow(other.real, 2) + pow(other.imaginary, 2);
	double imag_numerator   = self.imaginary * other.real - self.real * other.imaginary;
	double imag_denominator = real_denominator;
	return (ComplexCartesian) {
		.real = real_numerator / real_denominator,
		.imaginary = imag_numerator / imag_denominator,
	};
}
